# FoundationClasses
TKernel
NCollection

# FoundationClasses
TKernel
NCollection

# NCollection_BaseCollection< TheItemType >::Iterator Class Reference

`#include <NCollection_BaseCollection.hxx>`

Inheritance diagram for NCollection_BaseCollection< TheItemType >::Iterator:

[legend]

## Public Member Functions

virtual Standard_Boolean | More (void) const =0
| Query if the end of collection is reached by iterator.
virtual void | Next (void)=0
| Make a step along the collection.
virtual const TheItemType & | Value (void) const =0
| Value inquiry.
virtual TheItemType & | ChangeValue (void) const =0
| Value change access.

## Protected Member Functions

| Iterator (void)
| Empty constructor.
const Iterator & | operator= (const Iterator &)
| operator= is prohibited
| Iterator (const Iterator &)
| Copy constructor **.

### template<class TheItemType>
class NCollection_BaseCollection< TheItemType >::Iterator

## Constructor & Destructor Documentation

template<class TheItemType>
NCollection_BaseCollection< TheItemType >::Iterator::Iterator | ( | void |  | ) | `[inline, protected]`

Reimplemented in NCollection_Array1< TheItemType >::Iterator, NCollection_Array2< TheItemType >::Iterator, NCollection_DataMap< TheKeyType, TheItemType >::Iterator, NCollection_DoubleMap< TheKey1Type, TheKey2Type >::Iterator, NCollection_IndexedDataMap< TheKeyType, TheItemType >::Iterator, NCollection_IndexedMap< TheKeyType >::Iterator, NCollection_Map< TheKeyType >::Iterator, NCollection_Sequence< TheItemType >::Iterator, and NCollection_Vector< TheItemType >::Iterator.

template<class TheItemType>
NCollection_BaseCollection< TheItemType >::Iterator::Iterator | ( | const Iterator & |  | ) | `[inline, protected]`

| Reimplemented in NCollection_Vector< TheItemType >::Iterator.

## Member Function Documentation

template<class TheItemType>
virtual TheItemType& NCollection_BaseCollection< TheItemType >::Iterator::ChangeValue | ( | void |  | ) | const`[pure virtual]`

Implemented in NCollection_Array1< TheItemType >::Iterator, NCollection_Array2< TheItemType >::Iterator, NCollection_DataMap< TheKeyType, TheItemType >::Iterator, NCollection_DoubleMap< TheKey1Type, TheKey2Type >::Iterator, NCollection_IndexedDataMap< TheKeyType, TheItemType >::Iterator, NCollection_IndexedMap< TheKeyType >::Iterator, NCollection_Map< TheKeyType >::Iterator, NCollection_Sequence< TheItemType >::Iterator, NCollection_SList< TheItemType >, NCollection_TListIterator< TheItemType >, and NCollection_Vector< TheItemType >::Iterator.

template<class TheItemType>
virtual Standard_Boolean NCollection_BaseCollection< TheItemType >::Iterator::More | ( | void |  | ) | const`[pure virtual]`

Implemented in NCollection_Array1< TheItemType >::Iterator, NCollection_Array2< TheItemType >::Iterator, NCollection_DataMap< TheKeyType, TheItemType >::Iterator, NCollection_DoubleMap< TheKey1Type, TheKey2Type >::Iterator, NCollection_IndexedDataMap< TheKeyType, TheItemType >::Iterator, NCollection_IndexedMap< TheKeyType >::Iterator, NCollection_Map< TheKeyType >::Iterator, NCollection_Sequence< TheItemType >::Iterator, NCollection_SList< TheItemType >, NCollection_TListIterator< TheItemType >, and NCollection_Vector< TheItemType >::Iterator.

template<class TheItemType>
virtual void NCollection_BaseCollection< TheItemType >::Iterator::Next | ( | void |  | ) | `[pure virtual]`

Implemented in NCollection_Array1< TheItemType >::Iterator, NCollection_Array2< TheItemType >::Iterator, NCollection_DataMap< TheKeyType, TheItemType >::Iterator, NCollection_DoubleMap< TheKey1Type, TheKey2Type >::Iterator, NCollection_IndexedDataMap< TheKeyType, TheItemType >::Iterator, NCollection_IndexedMap< TheKeyType >::Iterator, NCollection_Map< TheKeyType >::Iterator, NCollection_Sequence< TheItemType >::Iterator, NCollection_SList< TheItemType >, NCollection_TListIterator< TheItemType >, NCollection_Vector< TheItemType >::Iterator, Poly_CoherentTriangulation::IteratorOfNode, and Poly_CoherentTriangulation::IteratorOfLink.

template<class TheItemType>
const Iterator& NCollection_BaseCollection< TheItemType >::Iterator::operator= | ( | const Iterator & |  | ) | `[protected]`

| Reimplemented in NCollection_Sequence< TheItemType >::Iterator, and NCollection_Vector< TheItemType >::Iterator.

template<class TheItemType>
virtual const TheItemType& NCollection_BaseCollection< TheItemType >::Iterator::Value | ( | void |  | ) | const`[pure virtual]`

Implemented in NCollection_Array1< TheItemType >::Iterator, NCollection_Array2< TheItemType >::Iterator, NCollection_DataMap< TheKeyType, TheItemType >::Iterator, NCollection_DoubleMap< TheKey1Type, TheKey2Type >::Iterator, NCollection_IndexedDataMap< TheKeyType, TheItemType >::Iterator, NCollection_IndexedMap< TheKeyType >::Iterator, NCollection_Map< TheKeyType >::Iterator, NCollection_Sequence< TheItemType >::Iterator, NCollection_SList< TheItemType >, NCollection_TListIterator< TheItemType >, and NCollection_Vector< TheItemType >::Iterator.

The documentation for this class was generated from the following file:

- NCollection_BaseCollection.hxx